// DAC
#include <Wire.h>
#include <Adafruit_MCP4725.h>

// DAC I2C Address
#define DAC_ADDRESS 0x62

// Connect DAC out to A6 this to test it

// DAC
Adafruit_MCP4725 dac;

uint32_t dac_value = 0;
int adcValueRead;
float voltageRead;

// DAC select
#define PIN_DACA0_1 10
#define PIN_DACA0_2 8
#define PIN_DACA0_3 9

// select DAC chip using DAC A0-pin (index from 0-)
void dacSelect(byte dacChip)
{
  switch (dacChip) {
    case 0:
      digitalWrite(PIN_DACA0_1, LOW);
      digitalWrite(PIN_DACA0_2, HIGH);
      digitalWrite(PIN_DACA0_3, HIGH);
      break;
    case 1:
      digitalWrite(PIN_DACA0_1, HIGH);
      digitalWrite(PIN_DACA0_2, LOW);
      digitalWrite(PIN_DACA0_3, HIGH);
      break;
    case 2:
      digitalWrite(PIN_DACA0_1, HIGH);
      digitalWrite(PIN_DACA0_2, HIGH);
      digitalWrite(PIN_DACA0_3, LOW);
      break;
  }
}


void setup()
{
  Serial.begin(115200);
  
    // DAC select

  pinMode(PIN_DACA0_1, OUTPUT);
  pinMode(PIN_DACA0_2, OUTPUT);
  pinMode(PIN_DACA0_3, OUTPUT);

  dac.begin(DAC_ADDRESS);
  dacSelect(0);
}



void loop()
{
  dac_value++;
  if (dac_value > 4095) {
    dac_value = 0;
  }

  dac.setVoltage(dac_value, false);

  Serial.print("DAC value: ");
  Serial.print(dac_value);

  delay(20);
  
  adcValueRead = analogRead(A7);
  voltageRead = adcValueRead * 4;

  Serial.print(" ADC Value: ");
  Serial.print(adcValueRead);
  Serial.print(" ADC*4: ");      
  Serial.print(voltageRead,3);      
  Serial.println();

  delay(180);

}
